'use strict';

/* globals require */

var gulp	= require('gulp'),
	jshint	= require('gulp-jshint'),
	beep	= require('beepbeep'),
	rename	= require('gulp-rename'),
	concat	= require('gulp-concat'),
	stylish	= require('jshint-stylish'),
	watch	= require('gulp-watch'),
	uglify	= require('gulp-uglify')
	;

var FN_BASE = 'flcoder';

var PATHS = {}, SRCS = {};

PATHS.YAR	= './node_modules/yarjs/dist/yar.min.js';
PATHS.HEAD	= './src/head.js';
PATHS.LIB	= './src/lib/**/*.js';
PATHS.TAIL	= './src/tail.js';
PATHS.DIST	= './dist';

SRCS.HINT	= ['./src/**/*.js'];
SRCS.DIST	= [PATHS.YAR, PATHS.HEAD, PATHS.LIB, PATHS.TAIL];

function errorbeep(){ beep([75,75]); }

gulp.task('build', function() {

	beep([0]);

	gulp.src(SRCS.HINT)
		.pipe(jshint())
		.pipe(jshint.reporter(stylish))
		.pipe(jshint.reporter(errorbeep));

		
	gulp.src(SRCS.DIST)
		.pipe(concat(FN_BASE+'.js'))
		.pipe(gulp.dest(PATHS.DIST))
		.pipe(rename(FN_BASE+'.min.js'))
		.pipe(uglify())
		.pipe(gulp.dest(PATHS.DIST));

});

gulp.task('watch', ['build'], function() {

	watch(SRCS.DIST, function() {
		gulp.start('build');
	});

});

gulp.task('default', ['watch']);