(function() {

	'use strict';

	function Store(app_id, version) {

		var cache = {};
		var prefix = app_id+'_'+version+'_';

		function getKey(member, v) {
		
			return v ? app_id+'_'+v+'_'+member : prefix+member;
		
		}

		this.get = function(member, v) {
			
			return cache[member] || (cache[member] = JSON.parse(localStorage[getKey(member,v)]));

		};

		this.save = function(member, value, v) {
			cache[member] = value;
			localStorage[getKey(member,v)] = JSON.stringify(value);
		};

	}

	__export('Store', Store);

})();