(function() {

	'use strict';

	__import(
	
		'DomCache, Chaining',

		function(DomCache, Chaining) {

			function Table(useBootstrapClasses) {

				var cache = {
					col: new DomCache('<th class="flc-table-col"></th>'),
					row: new DomCache('<tr class="flc-table-row"></tr>'),
					cel: new DomCache('<td class="flc-table-cel"></td>')
				};

				var cols = [];
				var rows = [];

				var table		= $('<table>');
				var thead		= $('<thead>');
				var tbody		= $('<tbody>');
				var toptr		= $('<tr>');
				
				if( useBootstrapClasses !== false ) table.addClass('table table-striped');

				table.append(thead);
				table.append(tbody);
				
				thead.append(toptr);
				
				table.update = function update(new_cols, new_rows) {
					
					var i, j, row;

					for(i in new_cols) {
						( cols[i] || Chaining.push(cols, cache.col().appendTo(toptr)) )
							.html(''+new_cols[i]);
					}

					for(i in new_rows) {
						row = rows[i] || Chaining.push(rows, cache.row().appendTo(tbody));
						row.cells = row.cells || [];
						for(j in new_rows[i]) {
							( row.cells[j] || Chaining.push(row.cells, cache.cel().appendTo(row)) )
								.html(''+new_rows[i][j]);
						}
					}

				};

				this.table = table;

			}

			__export('Table', Table);

		}

	);
	

})();